diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockMoss.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicMoss.java
similarity index 74%
rename from game/core/src/main/java/net/minecraft/core/block/BlockMoss.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockLogicMoss.java
index 86fc4ab67..00f2150aa 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockMoss.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicMoss.java
@@ -13,12 +13,12 @@ import java.util.Map;
 import java.util.Map.Entry;
 import java.util.Random;
 
-public class BlockMoss extends Block implements IBonemealable {
+public class BlockLogicMoss extends BlockLogic implements IBonemealable {
 	public static Map<Integer, Integer> variantMap = new HashMap<>();
-	public BlockMoss(String key, String namespaceId, int id, int parentId) {
-		super(key, namespaceId, id, Material.moss);
-		setTicking(true);
-		variantMap.put(parentId, id);
+	public BlockLogicMoss(Block<?> block, Block<?> parentBlock) {
+		super(block, Material.moss);
+		block.setTicking(true);
+		variantMap.put(parentBlock.id(), block.id());
 	}
 
 	@Override
@@ -54,9 +54,9 @@ public class BlockMoss extends Block implements IBonemealable {
 		}
 		
 		if (ignoreLight || !Block.isBuried(world, mossX, mossY, mossZ)) {
-			Block mossStone = getMossBlock(world.getBlockId(mossX, mossY, mossZ));
+			Block<?> mossStone = getMossBlock(world.getBlockId(mossX, mossY, mossZ));
 			if (mossStone != null) {
-				world.setBlockWithNotify(mossX, mossY, mossZ, mossStone.id);
+				world.setBlockWithNotify(mossX, mossY, mossZ, mossStone.id());
 				return true;
 			}
 		}
@@ -73,30 +73,33 @@ public class BlockMoss extends Block implements IBonemealable {
 		return true;
 	}
 
-	public static Block getMossBlock(int blockId) {
+	public static Block<?> getMossBlock(int blockId) {
 		if (blockId == 0)
 			return null;
 		return getMossBlock(Blocks.blocksList[blockId]);
 	}
 
-	public static Block getMossBlock(Block stoneBlock) {
+	public static Block<?> getMossBlock(Block<?> stoneBlock) {
 		return stoneToMossMap.get(stoneBlock);
 	}
 	
-	public static Block getStoneBlock(int blockId) {
+	public static Block<?> getStoneBlock(int blockId) {
 		if (blockId == 0)
 			return null;
 		return getStoneBlock(Blocks.blocksList[blockId]);
 	}
 	
-	public static Block getStoneBlock(Block mossBlock) {
+	public static Block<?> getStoneBlock(Block<?> mossBlock) {
 		return mossToStoneMap.get(mossBlock);
 	}
 
-	public static final Map<Block, Block> stoneToMossMap = new HashMap<>();
-	public static final Map<Block, Block> mossToStoneMap = new HashMap<>();
+	public static final Map<Block<?>, Block<?>> stoneToMossMap = new HashMap<>();
+	public static final Map<Block<?>, Block<?>> mossToStoneMap = new HashMap<>();
 
 	public static void initMossMap() {
+		stoneToMossMap.clear();
+		mossToStoneMap.clear();
+
 		stoneToMossMap.put(Blocks.STONE, Blocks.MOSS_STONE);
 		stoneToMossMap.put(Blocks.GRANITE, Blocks.MOSS_GRANITE);
 		stoneToMossMap.put(Blocks.LIMESTONE, Blocks.MOSS_LIMESTONE);
@@ -105,7 +108,7 @@ public class BlockMoss extends Block implements IBonemealable {
 		stoneToMossMap.put(Blocks.BRICK_STONE_POLISHED, Blocks.BRICK_STONE_POLISHED_MOSSY);
 		stoneToMossMap.put(Blocks.LOG_OAK, Blocks.LOG_OAK_MOSSY);
 		
-		for(Entry<Block, Block> entry : stoneToMossMap.entrySet()) {
+		for(Entry<Block<?>, Block<?>> entry : stoneToMossMap.entrySet()) {
 			mossToStoneMap.put(entry.getValue(), entry.getKey());
 		}
 	}
@@ -145,20 +148,21 @@ public class BlockMoss extends Block implements IBonemealable {
 					continue;
 				}
 
-				if(world.getBlockId(k1, l1, i2) == Blocks.STONE.id)
-					world.setBlockWithNotify(k1, l1, i2, Blocks.MOSS_STONE.id);
-				else if(world.getBlockId(k1, l1, i2) == Blocks.LIMESTONE.id)
-					world.setBlockWithNotify(k1, l1, i2, Blocks.MOSS_LIMESTONE.id);
-				else if(world.getBlockId(k1, l1, i2) == Blocks.GRANITE.id)
-					world.setBlockWithNotify(k1, l1, i2, Blocks.MOSS_GRANITE.id);
-				else if(world.getBlockId(k1, l1, i2) == Blocks.BASALT.id)
-					world.setBlockWithNotify(k1, l1, i2, Blocks.MOSS_BASALT.id);
-				else if(world.getBlockId(k1, l1, i2) == Blocks.COBBLE_STONE.id)
-					world.setBlockWithNotify(k1, l1, i2, Blocks.COBBLE_STONE_MOSSY.id);
-				else if(world.getBlockId(k1, l1, i2) == Blocks.BRICK_STONE_POLISHED.id)
-					world.setBlockWithNotify(k1, l1, i2, Blocks.BRICK_STONE_POLISHED_MOSSY.id);
-				else if(world.getBlockId(k1, l1, i2) == Blocks.LOG_OAK.id)
-					world.setBlockWithNotify(k1, l1, i2, Blocks.LOG_OAK_MOSSY.id);
+				int blockId = world.getBlockId(k1, l1, i2);
+				if(blockId == Blocks.STONE.id())
+					world.setBlockWithNotify(k1, l1, i2, Blocks.MOSS_STONE.id());
+				else if(blockId == Blocks.LIMESTONE.id())
+					world.setBlockWithNotify(k1, l1, i2, Blocks.MOSS_LIMESTONE.id());
+				else if(blockId == Blocks.GRANITE.id())
+					world.setBlockWithNotify(k1, l1, i2, Blocks.MOSS_GRANITE.id());
+				else if(blockId == Blocks.BASALT.id())
+					world.setBlockWithNotify(k1, l1, i2, Blocks.MOSS_BASALT.id());
+				else if(blockId == Blocks.COBBLE_STONE.id())
+					world.setBlockWithNotify(k1, l1, i2, Blocks.COBBLE_STONE_MOSSY.id());
+				else if(blockId == Blocks.BRICK_STONE_POLISHED.id())
+					world.setBlockWithNotify(k1, l1, i2, Blocks.BRICK_STONE_POLISHED_MOSSY.id());
+				else if(blockId == Blocks.LOG_OAK.id())
+					world.setBlockWithNotify(k1, l1, i2, Blocks.LOG_OAK_MOSSY.id());
 
 			}
 
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockMotionSensor.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicMotionSensor.java
similarity index 89%
rename from game/core/src/main/java/net/minecraft/core/block/BlockMotionSensor.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockLogicMotionSensor.java
index 7f9756446..2c0bcdb7c 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockMotionSensor.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicMotionSensor.java
@@ -13,14 +13,15 @@ import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.WorldSource;
 
-public class BlockMotionSensor extends BlockTileEntityVeryRotatable
+public class BlockLogicMotionSensor extends BlockLogicVeryRotatable
 {
     public final boolean isActive;
 
-    public BlockMotionSensor(String key, String namespaceId, int id, boolean isActive)
+    public BlockLogicMotionSensor(Block<?> block, boolean isActive)
     {
-        super(key, namespaceId, id, Material.glass);
+        super(block, Material.glass);
         this.isActive = isActive;
+        block.withEntity(TileEntitySensor::new);
     }
 
     @Override
@@ -70,12 +71,6 @@ public class BlockMotionSensor extends BlockTileEntityVeryRotatable
         return isActive;
     }
 
-    @Override
-	protected TileEntity getNewBlockEntity()
-    {
-        return new TileEntitySensor();
-    }
-
     @Override
     public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int meta, TileEntity tileEntity) {
         if (dropCause == EnumDropCause.IMPROPER_TOOL) {
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockMud.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicMud.java
similarity index 78%
rename from game/core/src/main/java/net/minecraft/core/block/BlockMud.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockLogicMud.java
index 10c9c4c29..ac2356d97 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockMud.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicMud.java
@@ -12,10 +12,10 @@ import net.minecraft.core.world.World;
 
 import java.util.Random;
 
-public class BlockMud extends Block{
-    public BlockMud(String key, String namespaceId, int id, Material material, boolean isHardened)
+public class BlockLogicMud extends BlockLogic {
+    public BlockLogicMud(Block<?> block, Material material, boolean isHardened)
     {
-        super(key, namespaceId, id, material);
+        super(block, material);
         this.isHardened = isHardened;
     }
 
@@ -28,7 +28,7 @@ public class BlockMud extends Block{
     @Override
 	public void onBlockPlacedByWorld(World world, int x, int y, int z)
     {
-        world.scheduleBlockUpdate(x, y, z, id, tickDelay());
+        world.scheduleBlockUpdate(x, y, z, block.id(), tickDelay());
     }
 
     private boolean isWaterNearby(final World world, final int x, final int y, final int z, int range)
@@ -39,7 +39,7 @@ public class BlockMud extends Block{
             {
                 for (int z1 = z - range; z1 <= z + range; z1++)
                 {
-                    if (Block.hasTag(world.getBlockId(x1, y1, z1), BlockTags.IS_WATER))
+                    if (Blocks.hasTag(world.getBlockId(x1, y1, z1), BlockTags.IS_WATER))
                     {
                         return true;
                     }
@@ -59,7 +59,7 @@ public class BlockMud extends Block{
             {
                 for (int z1 = z - 1; z1 <= z + 1; z1++)
                 {
-                    if (Block.hasTag(world.getBlockId(x1, y1, z1), BlockTags.IS_LAVA))
+                    if (Blocks.hasTag(world.getBlockId(x1, y1, z1), BlockTags.IS_LAVA))
                     {
                         return true;
                     }
@@ -87,7 +87,7 @@ public class BlockMud extends Block{
                     {
                         //...And the block is next to another wet mud block, it can become wet
                         int bID = world.getBlockId(x1, y1, z1);
-                        if (bID == Blocks.MUD.id || (bID == Blocks.FARMLAND_DIRT.id && BlockFarmland.isWet(world.getBlockMetadata(x1, y1, z1))))
+                        if (bID == Blocks.MUD.id() || (bID == Blocks.FARMLAND_DIRT.id() && BlockLogicFarmland.isWet(world.getBlockMetadata(x1, y1, z1))))
                         {
                             return true;
                         }
@@ -102,7 +102,7 @@ public class BlockMud extends Block{
     @Override
 	public void onNeighborBlockChange(World world, int x, int y, int z, int blockId)
     {
-        world.scheduleBlockUpdate(x, y, z, id, tickDelay());
+        world.scheduleBlockUpdate(x, y, z, block.id(), tickDelay());
     }
 
 
@@ -114,7 +114,7 @@ public class BlockMud extends Block{
 
     private void tryToFall(World world, int x, int y, int z)
     {
-        if(world.getBlockId(x, y, z) == Blocks.MUD_BAKED.id){
+        if(world.getBlockId(x, y, z) == Blocks.MUD_BAKED.id()){
             return;
         }
 
@@ -130,12 +130,12 @@ public class BlockMud extends Block{
                 for(; canFallBelow(world, x, y - 1, z) && y > 0; y--) { }
                 if(y > 0)
                 {
-                    world.setBlockWithNotify(x, y, z, id);
+                    world.setBlockWithNotify(x, y, z, block.id());
 
                 }
             } else
             {
-                EntityFallingBlock entityFallingBlock = new EntityFallingBlock(world, x + 0.5, y + 0.5, z + 0.5, id, 0, null);
+                EntityFallingBlock entityFallingBlock = new EntityFallingBlock(world, x + 0.5, y + 0.5, z + 0.5, block.id(), 0, null);
                 world.entityJoinedWorld(entityFallingBlock);
             }
         }
@@ -144,19 +144,7 @@ public class BlockMud extends Block{
     public static boolean canFallBelow(World world, int x, int y, int z)
     {
         int blockId = world.getBlockId(x, y, z);
-        if(blockId == 0)
-        {
-            return true;
-        }
-        if(blockId == Blocks.FIRE.id)
-        {
-            return true;
-        }
-        if(Block.hasTag(blockId, BlockTags.IS_WATER))
-        {
-            return true;
-        }
-        return Block.hasTag(blockId, BlockTags.IS_LAVA);
+        return blockId == 0 || blockId == Blocks.FIRE.id() || Blocks.hasTag(blockId, BlockTags.IS_WATER) || Blocks.hasTag(blockId, BlockTags.IS_LAVA);
     }
 
 
@@ -167,8 +155,8 @@ public class BlockMud extends Block{
         if(isHardened) {
             if(!isLavaNearby(world, x, y, z)) {
                 if (canBecomeWet(world, x, y, z)) {
-                    world.setBlock(x, y, z, Blocks.MUD.id);
-                    world.notifyBlockChange(x, y, z, Blocks.MUD.id);
+                    world.setBlock(x, y, z, Blocks.MUD.id());
+                    world.notifyBlockChange(x, y, z, Blocks.MUD.id());
                     return;
                 }
             }
@@ -176,14 +164,14 @@ public class BlockMud extends Block{
 
         // dry out mud
         if(!isHardened){
-            if(isLavaNearby(world, x, y, z) || world.dimension.id == Dimension.NETHER.id) {
+            if(isLavaNearby(world, x, y, z) || world.dimension == Dimension.NETHER) {
                 world.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, x + 0.5D, y + 0.5D, z + 0.5D, "random.fizz", 0.5F, 2.6F + (world.rand.nextFloat() - world.rand.nextFloat()) * 0.8F);
                 for(int l = 0; l < 8; l++)
                 {
                     world.spawnParticle("largesmoke", (double)x + Math.random(), (double)y + Math.random(), (double)z + Math.random(), 0.0D, 0.0D, 0.0D, 0);
                 }
-                world.setBlock(x, y, z, Blocks.MUD_BAKED.id);
-                world.notifyBlockChange(x, y, z, Blocks.MUD_BAKED.id);
+                world.setBlock(x, y, z, Blocks.MUD_BAKED.id());
+                world.notifyBlockChange(x, y, z, Blocks.MUD_BAKED.id());
                 return;
             }
         }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockMushroom.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicMushroom.java
similarity index 84%
rename from game/core/src/main/java/net/minecraft/core/block/BlockMushroom.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockLogicMushroom.java
index 4b2bb9d9d..8b58a6564 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockMushroom.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicMushroom.java
@@ -4,15 +4,15 @@ import net.minecraft.core.world.World;
 
 import java.util.Random;
 
-public class BlockMushroom extends BlockFlower
+public class BlockLogicMushroom extends BlockLogicFlower
 {
 
-	public BlockMushroom(String key, String namespaceId, int id)
+	public BlockLogicMushroom(Block<?> block)
     {
-        super(key, namespaceId, id);
+        super(block);
         float f = 0.2F;
         setBlockBounds(0.5F - f, 0.0F, 0.5F - f, 0.5F + f, f * 2.0F, 0.5F + f);
-        setTicking(true);
+        block.setTicking(true);
     }
 
     @Override
@@ -29,7 +29,7 @@ public class BlockMushroom extends BlockFlower
                 int z2 = z + rand.nextInt(3) - 1;
                 if(world.isAirBlock(x2, randY, z2) && canBlockStay(world, x2, randY, z2))
                 {
-                    world.setBlockWithNotify(x2, randY, z2, id);
+                    world.setBlockWithNotify(x2, randY, z2, block.id());
                 }
             }
         }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockNetherrackIgneous.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicNetherrackIgneous.java
similarity index 73%
rename from game/core/src/main/java/net/minecraft/core/block/BlockNetherrackIgneous.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockLogicNetherrackIgneous.java
index e6ef87d3d..27e3a4e03 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockNetherrackIgneous.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicNetherrackIgneous.java
@@ -10,10 +10,10 @@ import net.minecraft.core.world.WorldSource;
 
 import java.util.Random;
 
-public class BlockNetherrackIgneous extends Block{
-    public BlockNetherrackIgneous(String translationKey, String namespaceId, int id) {
-        super(translationKey, namespaceId, id, Material.netherrack);
-        setTicking(true);
+public class BlockLogicNetherrackIgneous extends BlockLogic {
+    public BlockLogicNetherrackIgneous(Block<?> block) {
+        super(block, Material.netherrack);
+        block.setTicking(true);
     }
 
     @Override
@@ -37,19 +37,19 @@ public class BlockNetherrackIgneous extends Block{
 
     @Override
     public void onNeighborBlockChange(World world, int x, int y, int z, int blockId) {
-        world.scheduleBlockUpdate(x, y, z, id, tickDelay() + world.rand.nextInt(5) - world.rand.nextInt(5));
+        world.scheduleBlockUpdate(x, y, z, block.id(), tickDelay() + world.rand.nextInt(5) - world.rand.nextInt(5));
     }
 
     @Override
     public void onBlockPlacedByWorld(World world, int x, int y, int z) {
-        world.scheduleBlockUpdate(x, y, z, id, tickDelay() + world.rand.nextInt(5) - world.rand.nextInt(5));
+        world.scheduleBlockUpdate(x, y, z, block.id(), tickDelay() + world.rand.nextInt(5) - world.rand.nextInt(5));
     }
 
     public boolean canMelt(World world, int x, int y, int z) {
         boolean canMelt = false;
         for (Side side : Side.sides) {
-            Block block = world.getBlock(x + side.getOffsetX(), y + side.getOffsetY(), z + side.getOffsetZ());
-            Material adjacentMaterial = block == null ? Material.air : block.blockMaterial;
+            Block<?> block = world.getBlock(x + side.getOffsetX(), y + side.getOffsetY(), z + side.getOffsetZ());
+            Material adjacentMaterial = block == null ? Material.air : block.getMaterial();
             if (adjacentMaterial == Material.water) {
                 return false;
             }
@@ -61,7 +61,7 @@ public class BlockNetherrackIgneous extends Block{
     @Override
     public void updateTick(World world, int x, int y, int z, Random rand) {
         if (canMelt(world, x, y, z)) {
-            world.setBlockWithNotify(x, y, z, Blocks.FLUID_LAVA_FLOWING.id);
+            world.setBlockWithNotify(x, y, z, Blocks.FLUID_LAVA_FLOWING.id());
         }
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockNote.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicNote.java
similarity index 90%
rename from game/core/src/main/java/net/minecraft/core/block/BlockNote.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockLogicNote.java
index 095bda4b3..f8be60f35 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockNote.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicNote.java
@@ -2,7 +2,6 @@ package net.minecraft.core.block;
 
 import com.mojang.logging.LogUtils;
 import net.minecraft.core.block.entity.TileEntityActivator;
-import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.sound.SoundCategory;
 import net.minecraft.core.util.helper.Direction;
@@ -16,7 +15,7 @@ import org.slf4j.Logger;
 import java.util.HashMap;
 import java.util.Map;
 
-public class BlockNote extends BlockTileEntity
+public class BlockLogicNote extends BlockLogic
 {
     private static final Logger LOGGER = LogUtils.getLogger();
     public static final int MASK_NOTE = 0b0011_1111;
@@ -24,9 +23,10 @@ public class BlockNote extends BlockTileEntity
 
     public static final byte MAX_NOTE = 24;
 
-    public BlockNote(String key, String namespaceId, int id)
+    public BlockLogicNote(Block<?> block)
     {
-        super(key, namespaceId, id, Material.wood);
+        super(block, Material.wood);
+        block.withEntity(null);
     }
 
     @Override
@@ -108,18 +108,6 @@ public class BlockNote extends BlockTileEntity
         world.spawnParticle("note", (double) x + 0.5D, (double) y + 1.2D, (double) z + 0.5D, 0.0, 0.0D, 0.0D, data);
     }
 
-
-    // These below 2 methods are for Legacy noteblock entity support, do not delete them or terrible things will happen
-    @Override
-    public void onBlockPlacedByWorld(World world, int x, int y, int z)
-    {
-    }
-
-    @Override
-    protected TileEntity getNewBlockEntity() {
-        return null;
-    }
-
     public static class Instrument {
         public static final Map<Integer, Instrument> instrumentMap = new HashMap<>();
         public final int index;
@@ -139,20 +127,20 @@ public class BlockNote extends BlockTileEntity
             return instrumentMap.getOrDefault(index, DEFAULT);
         }
 
-        public static @NotNull Instrument getInstrumentFromBlock(@Nullable Block block) {
+        public static @NotNull Instrument getInstrumentFromBlock(@Nullable Block<?> block) {
             if (block == null) return DEFAULT;
 
             if (block == Blocks.BLOCK_OLIVINE) {
                 return CHIP_TRIANGLE;
             }
-            if (block == Blocks.BLOCK_REDSTONE || block == Blocks.PUMPKIN_REDSTONE || block instanceof BlockOreRedstone) { // Should be any block thats basically just redstone
+            if (block == Blocks.BLOCK_REDSTONE || block == Blocks.PUMPKIN_REDSTONE || block.getLogic() instanceof BlockLogicOreRedstone) { // Should be any block thats basically just redstone
                 return GUITAR_ELECTRIC;
             }
             if (block == Blocks.CHEST_PLANKS_OAK || block == Blocks.CHEST_PLANKS_OAK_PAINTED) {
                 return WOOD_BLOCK;
             }
 
-            Material material = block.blockMaterial;
+            Material material = block.getMaterial();
             if (material == Material.permafrost || material == Material.ice) {
                 return CELESTA;
             }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockOreCoal.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicOreCoal.java
similarity index 80%
rename from game/core/src/main/java/net/minecraft/core/block/BlockOreCoal.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockLogicOreCoal.java
index 4ba57e030..4664fdd7a 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockOreCoal.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicOreCoal.java
@@ -10,13 +10,13 @@ import net.minecraft.core.world.World;
 import java.util.HashMap;
 import java.util.Map;
 
-public class BlockOreCoal extends Block
+public class BlockLogicOreCoal extends BlockLogic
 {
     public static Map<Integer, Integer> variantMap = new HashMap<>();
 
-    public BlockOreCoal(String key, String namespaceId, int id, int parentId, Material material){
-        super(key, namespaceId, id, material);
-        variantMap.put(parentId, id);
+    public BlockLogicOreCoal(Block<?> block, Block<?> parentBlock, Material material){
+        super(block, material);
+        variantMap.put(parentBlock.id(), block.id());
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockOreDiamond.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicOreDiamond.java
similarity index 80%
rename from game/core/src/main/java/net/minecraft/core/block/BlockOreDiamond.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockLogicOreDiamond.java
index 56f61dd6a..1d13014cc 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockOreDiamond.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicOreDiamond.java
@@ -10,13 +10,13 @@ import net.minecraft.core.world.World;
 import java.util.HashMap;
 import java.util.Map;
 
-public class BlockOreDiamond extends Block
+public class BlockLogicOreDiamond extends BlockLogic
 {
     public static Map<Integer, Integer> variantMap = new HashMap<>();
-    public BlockOreDiamond(String key, String namespaceId, int id, int parentId, Material material)
+    public BlockLogicOreDiamond(Block<?> block, Block<?> parentBlock, Material material)
     {
-        super(key, namespaceId, id, material);
-        variantMap.put(parentId, id);
+        super(block, material);
+        variantMap.put(parentBlock.id(), block.id());
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockOreGold.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicOreGold.java
similarity index 80%
rename from game/core/src/main/java/net/minecraft/core/block/BlockOreGold.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockLogicOreGold.java
index 243f0799b..28905c573 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockOreGold.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicOreGold.java
@@ -11,12 +11,12 @@ import java.util.HashMap;
 import java.util.Map;
 
 
-public class BlockOreGold extends Block {
+public class BlockLogicOreGold extends BlockLogic {
     public static Map<Integer, Integer> variantMap = new HashMap<>();
 
-    public BlockOreGold(String key, String namespaceId, int id, int parentId, Material material) {
-        super(key, namespaceId, id, material);
-        variantMap.put(parentId, id);
+    public BlockLogicOreGold(Block<?> block, Block<?> parentBlock, Material material) {
+        super(block, material);
+        variantMap.put(parentBlock.id(), block.id());
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockOreIron.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicOreIron.java
similarity index 81%
rename from game/core/src/main/java/net/minecraft/core/block/BlockOreIron.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockLogicOreIron.java
index 0707e8981..242dede8f 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockOreIron.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicOreIron.java
@@ -10,12 +10,12 @@ import net.minecraft.core.world.World;
 import java.util.HashMap;
 import java.util.Map;
 
-public class BlockOreIron extends Block
+public class BlockLogicOreIron extends BlockLogic
 {
     public static Map<Integer, Integer> variantMap = new HashMap<>();
-    public BlockOreIron(String key, String namespaceId, int id, int parentID, Material material) {
-        super(key, namespaceId, id, material);
-        variantMap.put(parentID, id);
+    public BlockLogicOreIron(Block<?> block, Block<?> parentBlock, Material material) {
+        super(block, material);
+        variantMap.put(parentBlock.id(), block.id());
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockOreLapis.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicOreLapis.java
similarity index 82%
rename from game/core/src/main/java/net/minecraft/core/block/BlockOreLapis.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockLogicOreLapis.java
index 822422768..dbfcc4240 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockOreLapis.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicOreLapis.java
@@ -11,13 +11,13 @@ import net.minecraft.core.world.World;
 import java.util.HashMap;
 import java.util.Map;
 
-public class BlockOreLapis extends Block
+public class BlockLogicOreLapis extends BlockLogic
 {
     public static Map<Integer, Integer> variantMap = new HashMap<>();
-    public BlockOreLapis(String key, String namespaceId, int id, int parentId, Material material)
+    public BlockLogicOreLapis(Block<?> block, Block<?> parentBlock, Material material)
     {
-        super(key, namespaceId, id, material);
-        variantMap.put(parentId, id);
+        super(block, material);
+        variantMap.put(parentBlock.id(), block.id());
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockOreNetherCoal.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicOreNetherCoal.java
similarity index 82%
rename from game/core/src/main/java/net/minecraft/core/block/BlockOreNetherCoal.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockLogicOreNetherCoal.java
index 52f7d1535..60d98c69d 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockOreNetherCoal.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicOreNetherCoal.java
@@ -7,12 +7,12 @@ import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.world.World;
 
-public class BlockOreNetherCoal extends Block
+public class BlockLogicOreNetherCoal extends BlockLogic
 {
 
-    public BlockOreNetherCoal(String key, String namespaceId, int id)
+    public BlockLogicOreNetherCoal(Block<?> block)
     {
-        super(key, namespaceId, id, Material.netherrack);
+        super(block, Material.netherrack);
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockOreRedstone.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicOreRedstone.java
similarity index 83%
rename from game/core/src/main/java/net/minecraft/core/block/BlockOreRedstone.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockLogicOreRedstone.java
index 188e28b22..858cdf7e0 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockOreRedstone.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicOreRedstone.java
@@ -13,26 +13,25 @@ import net.minecraft.core.block.material.Material;
 import java.util.HashMap;
 import java.util.Map;
 import java.util.Random;
-import java.util.function.Supplier;
 
-public class BlockOreRedstone extends Block
+public class BlockLogicOreRedstone extends BlockLogic
 {
     public static Map<Integer, Integer> variantMap = new HashMap<>();
     private final boolean illuminated;
-    private final Supplier<Block> normalBlock;
-    private final Supplier<Block> illuminatedBlock;
-    public BlockOreRedstone(String key, String namespaceId, int id, int parentId, Material material, boolean illuminated, Supplier<Block> normalBlock, Supplier<Block> illuminatedBlock)
+    private final Block<?> normalBlock;
+    private final Block<?> illuminatedBlock;
+    public BlockLogicOreRedstone(Block<?> block, Block<?> parentBlock, Material material, boolean illuminated, Block<?> normalBlock, Block<?> illuminatedBlock)
     {
-        super(key, namespaceId, id, material);
+        super(block, material);
         if(illuminated)
         {
-            setTicking(true);
+            block.setTicking(true);
         }
         this.illuminated = illuminated;
         this.normalBlock = normalBlock;
         this.illuminatedBlock = illuminatedBlock;
-        if (parentId > 0){
-            variantMap.put(parentId, id);
+        if (parentBlock != null){
+            variantMap.put(parentBlock.id(), block.id());
         }
     }
 
@@ -62,7 +61,7 @@ public class BlockOreRedstone extends Block
         spawnParticles(world, x, y, z);
         if (!illuminated)
         {
-        	world.setBlockWithNotify(x, y, z, illuminatedBlock.get().id);
+        	world.setBlockWithNotify(x, y, z, illuminatedBlock.id());
         }
     }
 
@@ -71,7 +70,7 @@ public class BlockOreRedstone extends Block
     {
         if(illuminated)
         {
-            world.setBlockWithNotify(x, y, z, normalBlock.get().id);
+            world.setBlockWithNotify(x, y, z, normalBlock.id());
         }
     }
 
@@ -82,7 +81,7 @@ public class BlockOreRedstone extends Block
         {
             case SILK_TOUCH:
             case PICK_BLOCK:
-                return new ItemStack[] { new ItemStack(normalBlock.get()) };
+                return new ItemStack[] { new ItemStack(normalBlock) };
             case EXPLOSION:
             case PROPER_TOOL:
             case PISTON_CRUSH:
